 	org $1001 - 2
 	dw  $1001
	
ysize = 9				; change these 4 value freely!
xsize = 10
;
ypos = (25-ysize)/2			; centered
xpos = (40-xsize)/2			; centered
;
saddr = ypos * 40 + xpos		; calculated Color map address, don't change
baddr = ypos * 320 + xpos * 8		; calculated bitmap address, don't change
;
sync = ypos * 8 + 2			; sync at rasterline, don't change

ph_a		= $80
ph_x		= $81
ph_y		= $82
 	
ptr		= $90
ptr2		= $92 
tptr		= $94
lines		= $96
cols		= $97  
line_a		= $98
vsin1		= $99
vsin2		= $9A
vsin3		= $9B
cycle		= $9C

src		= $A0
dst		= $A2
and_val1	= $A4
and_val2	= $A5

idx		= $B0			; 5 bytes (one for each bar)

code_address	= $8000
colors		= $6000

	dw	$100B,2003
	db	$9E,"4109",0,0,0

	; main start
	   
	sei
	sta $FF3F
	;
	lda #$00			; picture multi colors
	sta $FF15
	lda #$68
	sta $FF16
	lda #$00
	sta $FF19
	;
	lda #$00
	sta ptr				; set lower byte of pointer (to fix bug) :-)
	ldy #$80
	ldx #$1F
	jsr fill			; fill $8000-$9FFF with 0 (the bitmap to be revealed)
	;
	lda #$70
	ldy #$60
	ldx #$00
	jsr fill
	;
	lda #$07
	ldx #$00
	jsr fillC
	;
	lda #$01
	ldx #$00
	jsr fillC
	;
	lda #$10
	ldx #$00
	jsr fillC
;	;
;	; --- fill the pattern of the plasma
;	;
;	lda #baddr & 255		; start address lo
;	sta ptr   
;	lda #(baddr >> 8) + $20		; start address hi
;	sta ptr+1
;	;     
;	ldx #$00
;	;
;floop2	ldy #$00
;	lda #$A5			; plasma pattern
;floop1	sta (ptr),y       
;	iny
;	cpy #(xsize * 8)
;	bne floop1
;	;
;	lda ptr
;	clc
;	adc #$40
;	sta ptr
;	lda ptr+1
;	adc #$01
;	sta ptr+1			; add 320 to pointer (next line in bitmap)
;	;
;	inx
;	cpx #ysize      
;	bne floop2
	;
	; --- copy the color map 3 more times
	;
	ldy #$00
	sty ptr
	sty ptr2
	lda #$48
	sta ptr2+1
cl2	lda #$40
	sta ptr+1
	ldx #$07
cl1	lda (ptr),y
	sta (ptr2),y
	iny
	bne cl1
	inc ptr+1
	inc ptr2+1
	dex
	bpl cl1
	lda ptr2+1
	cmp #$60
	bne cl2
	;
	; ****************
	;
	; --- graphics on
	;
	lda #$3B
	sta $FF06
	;
	lda $FF07
	and #$40
	ora #$18
	sta ff07_val+1
	sta $FF07
	;
	lda $FF12
	and #$03
	ora #$E0
	sta $FF12
	;
	lda #$40
	sta $FF14
	;                
	; --- set irq
	;
xx1	lda $FF1D
	cmp #$F7
	bne xx1
	;
	lda #$02
	sta $FF0A
	;
	inc $FF09
	;
	lda #$30
	sta vsin1
	lda #$18
	sta vsin2
	sta vsin3
	;
	; ---
	;
	jsr reset_idx
	;
	cli
	;
wait1	lda idx+4
	cmp #$66
	bne wait1
	;
	lda $FF12			; switch the bitmap back to $2000
	and #$03
	ora #$C8
	sta $FF12
	;
	jsr generate_code		; this overwrites the "revealed" bitmap at $8000
	;
	sei
	lda #sync
	ldx #irq1 & 255
	ldy #irq1 >> 8
	sta $FF0B
	stx $FFFE
	sty $FFFF
	cli
	;
	jmp *
	
generate_code
	;
	; ### CODE GENERATION ###
	;
	lda #code_address & 255		; set the code start address
	sta cg+1
	lda #code_address >> 8
	sta cg+2
	;      
	; *************************
	;
	lda #saddr & 255		; start address lo
	sta ptr   
	sta ptr2
	lda #(saddr >> 8) + $40		; start address hi
	sta ptr+1
	clc
	adc #$04
	sta ptr2+1
	;   
	; ---
	;    
	lda #ysize*4-1
	sta lines
	;                      
	;				; --- plasma precalc for each line
cgl2	lda #$A9			; LDA #$nn opcode
	jsr pb
	lda lines
	jsr pb
	;
	lda #px0 & 255
	ldx #10
	jsr pbs
	;
	lda lines
	clc
	adc #$00
	jsr pb
	;
	lda #pxa & 255
	ldx #9
	jsr pbs
	;
	; ---
	lda #xsize-1			; *****
	sta cols
	;
	; for first iteration, skip LDA line_a, since it's already in A
	;
	lda #px1a & 255
	ldx #$03
	bne cgl1a			; always jump
	;
cgl1	lda #px1 & 255			; plasma x loop
	ldx #$05
cgl1a	jsr pbs
	;
	lda cols
	asl a
	jsr pb
	lda #sine2 >> 8
	jsr pb
	;
	lda #px2 & 255
	ldx #$02
	jsr pbs
	;
	lda cols
	asl a
	jsr pb
	lda #sine3 >> 8
	jsr pb
	;  
	lda #px3 & 255
	ldx #$08
	jsr pbs
	;
	lda cols
	clc
	adc ptr
	sta tptr
	lda ptr+1
	adc #$00
	sta tptr+1
	;
	lda tptr
	jsr pb
	lda tptr+1
	jsr pb
	;
	lda #px4 & 255
	ldx #$07
	jsr pbs
	;    
	lda cols
	clc
	adc ptr2
	sta tptr
	lda ptr2+1
	adc #$00
	sta tptr+1
	;
	lda tptr
	jsr pb
	lda tptr+1
	jsr pb
	;
	dec cols
	bpl cgl1
	;
	lda ptr+1			; POINTER INCREASE
	clc
	adc #$08			; high byte increase by $0800, next color ram
	sta ptr+1
	;clc
	;adc #$04
	ora #$04
	sta ptr2+1
	;
	cmp #$63			; no overflow yet
	bcc line_loop_end
	;
	; ---
	lda ptr				; inc ptr by 40
	clc
	adc #40
	sta ptr
	sta ptr2
	bcc no_inc_1
	;
	inc ptr+1
	inc ptr2+1
	;
no_inc_1
	;
	lda ptr+1			; go back to first color ram
	sec
	sbc #$20			; decrease address by $2000
	sta ptr+1
	clc
	adc #$04
	sta ptr2+1
	;
	;
line_loop_end
	;
	dec lines
	bmi cgl3
	;
;	lda lines			; --- break the code in two !
;	cmp #$1F			; line number to check			
;	bne cgl4
;	;
;	lda #$60			; add an RTS to the end of the first part
;	jsr pb
;	;
;	lda cg+1
;	sta code_2nd_part+1
;	lda cg+2
;	sta code_2nd_part+2
;	;
cgl4	jmp cgl2
	;
cgl3	lda #$60			; RTS at the end
	jmp pb				; also returns from _this_ subroutine (generate_code)
	;
	; ###################################################
	;
	; --- fill
	;        
fill	sty ptr+1
fillC	ldy #$00 
fill1	sta (ptr),y
	iny
	bne fill1
	inc ptr+1
	dex
	bpl fill1
	rts       
	
pbs	; pbs = PutBytes, copy X bytes from plasma_code + A
	sta pbs_1+1
	stx pbs_2+1
	ldx #$00
pbs_1	lda plasma_code,x
	jsr pb
	inx
pbs_2	cpx #$00
	bne pbs_1
	rts
	
pb	; pb = PutByte, stores A
cg	sta $FFFF
	;sta $FF19			; like decrunching effect
	;
	inc cg+1
	bne no_inc_cg
	inc cg+2
no_inc_cg
	rts    
	
	align 256
	
tab1	db $48,$50,$58,$40
	db $48,$50,$58,$40
	db $48,$50,$58,$40
	db $48,$50,$58,$40
	db $48,$50,$58,$40
	
	db $48,$50,$58,$40
	db $48,$50,$58,$40
	db $48,$50,$58,$40
	db $48,$50,$58,$40		; 9 lines of FLI
	;db $48,$50,$58,$40
	
tab2	db $3D,$3F,$39,$3B
	db $3D,$3F,$39,$3B
	db $3D,$3F,$39,$3B
	db $3D,$3F,$39,$3B
	db $3D,$3F,$39,$3B
	
	db $3D,$3F,$39,$3B
	db $3D,$3F,$39,$3B
	db $3D,$3F,$39,$3B
	db $3D,$3F,$39,$3B
	;db $3D,$3F,$39,$3B
	
plasma_code
	nop
	;
px0	nop;clc
	adc vsin1
	ldy vsin2			; 5
	adc sine2,y
	tax
	lda #$00			; 6
pxa	nop;clc
	adc sine,x
	nop;clc				; 5
	adc cycle			; 2
	sta line_a			; 2 = 
	;
px1	lda line_a
px1a	ldy vsin2
	adc $FFFF,y
px2	tax
	adc $FFFF,y
px3	tay
	lda colors+$0000,x
	ora colors+$0100,y
	sta $FFFF			; destination address
px4	lda colors+$0200,x
	ora colors+$0300,y
	sta $FFFF			; destination address
	nop
	
	align 256
irq1
	sta ph_a			; !!! must be on the same page as irq2 !!!
	stx ph_x
	sty ph_y
	;
	lda $FF1E			; Horiz Scan
	and #$04
	beq *+2
	;
	asl $FF09			; clear IRQ bit
	inc $FF0B			; cause IRQ in next line
	;
	lda #irq2 & 255
	sta $FFFE			; NMI Vector Lo Byte
	;  
	cli
	;
ff07_val
	lda #$08			; shake the screen
	sta $FF07
	;
	lda $FF12
	and #$03
ff12_val
	ora #$C8			; switch bitmaps
	sta $FF12
	;
	ldx #$00
	;nop
	;nop
	;nop
	;nop
	nop				; IRQ will kick in here
	nop
	nop
	nop
	;
	lda #$18			; reset horizontal scroll, reset bitmap
	sta $FF07
	;
	lda $FF12
	and #$03
	ora #$C8
	sta $FF12
	;
	; --- ************************* ; plasma movement code (once per frame)
	;
	lda xadd+1
	eor #$01			; add 1 in every odd cycle
	sta xadd+1
	;
	; ---
	;
	lda vsin1			; increase plasma sine values
	clc
	adc #$01
	cmp #94				; !sine wavelength
	bne pl8
	lda #$00
pl8	sta vsin1
	;
	lda vsin3
	clc
	adc #$01
	cmp #80				; !sine wavelength
	bne pl7
	lda #00
pl7	sta vsin3
	clc
xadd	adc #$00
	sta vsin2
	;   
	; ---
	;
	;dec $FF19			; debug !!!
	jsr code_address		; call the first of the code
	;inc $FF19			; debug !!!
	;
	lda ff07_val+1			; shake the screen...
	eor #$02		
	sta ff07_val+1
	;
	lda ff12_val+1			; switch to the shifted bitmap
	eor #($C8^$D8)
	sta ff12_val+1
	;
control
	ldx #$00
	bne ctrl1
	;
ctrl2	ldy #$00
	inc ctrl2+1
	lda jumps_lo,y
	sta ctrlC+1
	lda jumps_hi,y
	sta ctrlC+2
	;
ctrl1	inc control+1
ctrlC	jsr reveal_colors
	;
	; ---
	;
	lda ph_a
	ldx ph_x
	ldy ph_y
	;
	rti
	
irq2	cmp $EA				; 3
	;
	nop				; 12 (could be used for raster)
	nop
	nop
	nop
	nop
	nop
	;
	nop				; 2
	;
	lda tab1,x			; do the FLI
	sta $FF14			; Video Matrix
	lda tab2,x
	sta $FF06			; Vert Scroll
	;  
	nop				; 4
	nop
	;
	inx				; 2
	cpx #ysize*4			; (size in chars)*8/2!
	bne irq2
	;
	asl $FF09			; clear IRQ bit
	dec $FF0B			; Vert raster
	;
	lda #irq1 & 255
	sta $FFFE			; NMI Vector Lo Byte
	;
	rti
	
jumps_lo
	db reveal_colors & 255
	db do_nothing & 255
	db hide_colors & 255
	db start_clear & 255
	
jumps_hi
	db reveal_colors >> 8
	db do_nothing >> 8
	db hide_colors >> 8
	db start_clear >> 8
	
reveal_colors
	lda lum1,x
	sta colors+$0000,x
	lda lum2,x
	sta colors+$0100,x
	lda col1,x
	sta colors+$0200,x
	lda col2,x
	sta colors+$0300,x
do_nothing
	rts
	
hide_colors
	stx rc1+1
	lda #$FF
	sec
rc1	sbc #$00
	tax
	;
	lda #$70
	sta colors+$0000,x
	lda #$07
	sta colors+$0100,x
	lda #$01
	sta colors+$0200,x
	lda #$10
	sta colors+$0300,x
	rts
	
start_clear
	lda #$CC
	sta $FF0B
	lda #irq_clear & 255
	sta $FFFE
	lda #irq_clear >> 8
	sta $FFFF
	rts
	
irq_clear
	pha
	txa
	pha
	tya
	pha
	asl $FF09
	;
	ldx #$00
ic1	lda $2000,x
	sta $8000,x
	inx
	bne ic1
	;
	inc ic1+2
	inc ic1+5
	lda ic1+2
	cmp #$40		; $4000 - end of bitmap
	bne ic3
	;
	ldx #$04
ic2	lda and_values2,x
	sta and_values,x
	dex
	bpl ic2
	;
	jsr reset_idx
	;
	lda $FF12			; switch the bitmap back, for "reverse reveal"
	and #$03
	ora #$E0
	sta $FF12
	;
ic3	pla
	tay
	pla
	tax
	pla
	rti
	
reset_idx
	lda #12
	sta idx			; reveal index
	lda #9
	sta idx+1
	lda #6
	sta idx+2
	lda #3
	sta idx+3
	lda #0
	sta idx+4
	;
	lda #$CC
	sta $FF0B
	lda #irq_reveal & 255
	sta $FFFE
	lda #irq_reveal >> 8
	sta $FFFF
	rts
	
irq_reveal
	pha
	txa
	pha
	tya
	pha
	;
	asl $FF09
	;
	;inc $FF19			; debug !!!
	;
	ldy #$00
loop1	tya
	pha
	lda idx,y
	asl a
	tax
	;
	lda reveal_data_start_addr,x
	clc
	adc offset_lo,y
	sta src 
	sta dst
	;
	lda reveal_data_start_addr+1,x
	adc offset_hi,y
	sta src+1			; source is $2000
	bpl cp0
	jmp reveal_done
	;
cp0	clc
	adc #$60
	sta dst+1			; destination is $8000
	;
	lda reveal_data_and_value,x
	tay
	lda and_values,y
	sta and_val1
	lda reveal_data_and_value+1,x
	tay
	lda and_values,y
	sta and_val2
	;
	ldx #4				; number of rows to copy (5)
cp2	ldy #$00
	lda (src),y
	and and_val1
	sta (dst),y
	iny
	lda (src),y
	and and_val1
	sta (dst),y
	iny
	lda (src),y
	and and_val1
	sta (dst),y
	iny
	lda (src),y
	and and_val1
	sta (dst),y
	iny
	;
	lda (src),y
	and and_val1
	sta (dst),y
	iny
	lda (src),y
	and and_val1
	sta (dst),y
	iny
	lda (src),y
	and and_val1
	sta (dst),y
	iny
	lda (src),y
	and and_val1
	sta (dst),y
	iny
	bne cp2a			; always jump
	;
	; ---
	;
cp2b	bpl cp2 
cp2a	lda (src),y
	and and_val2
	sta (dst),y
	iny
	lda (src),y
	and and_val2
	sta (dst),y
	iny
	lda (src),y
	and and_val2
	sta (dst),y
	iny
	lda (src),y
	and and_val2
	sta (dst),y
	iny
	;
	lda (src),y
	and and_val2
	sta (dst),y
	iny
	lda (src),y
	and and_val2
	sta (dst),y
	iny
	lda (src),y
	and and_val2
	sta (dst),y
	iny
	lda (src),y
	and and_val2
	sta (dst),y
	;
	lda src
	clc
	adc #$40
	sta src
	sta dst
	lda src+1
	adc #$01
	sta src+1
	clc
	adc #$60
	sta dst+1			; destination is $8000
	;
	dex
	bpl cp2b
	;
cp3	pla
	tax
	pha
	inc idx,x
	;
reveal_done
	pla
	tay
	iny
	cpy #$05
	beq end1
	jmp loop1
	;
end1	;dec $FF19			; debug !!!
	;
	pla
	tay
	pla
	tax
	pla
	rti
	
offset_lo
	db $00
	db $40
	db $80
	db $C0
	db $00
	
offset_hi
	db $20				; points to $2000 (source bitmap)
	db $26
	db $2C
	db $32
	db $39
	
and_values
	db $00,$C0,$F0,$FC,$FF

and_values2
	db $FF,$3F,$0F,$03,$00
	
reveal_data_and_value
	db 0,0
	db 0,0
	db 0,0
	
	db 0,0
	db 0,0
	db 0,0
	
	db 0,0
	db 0,0
	db 0,0
	
	db 0,0
	db 0,0
	db 0,0
	
	db 4, ($05 & 3)+1
	db 4, ($0B & 3)+1
	db 4, ($10 & 3)+1
	db 4, ($15 & 3)+1
	db 4, ($1A & 3)+1
	db 4, ($1F & 3)+1
	db 4, ($24 & 3)+1
	db 4, ($29 & 3)+1
	db 4, ($2E & 3)+1
	db 4, ($32 & 3)+1
	
	db 4, ($37 & 3)+1
	db 4, ($3B & 3)+1
	db 4, ($3F & 3)+1
	db 4, ($43 & 3)+1
	db 4, ($46 & 3)+1
	db 4, ($4A & 3)+1
	db 4, ($4D & 3)+1
	db 4, ($50 & 3)+1
	db 4, ($53 & 3)+1
	db 4, ($55 & 3)+1
	
	db 4, ($58 & 3)+1
	db 4, ($5A & 3)+1
	db 4, ($5B & 3)+1
	db 4, ($5D & 3)+1
	db 4, ($5E & 3)+1
	db 4, ($5F & 3)+1
	db 4, ($60 & 3)+1
	db 4, ($61 & 3)+1
	db 4, ($61 & 3)+1
	db 4, ($61 & 3)+1
	
	db 4, ($61 & 3)+1
	db 4, ($61 & 3)+1
	
	db ($61 & 3)+1, 0
	db ($60 & 3)+1, 0
	db ($5F & 3)+1, 0
	db ($5E & 3)+1, 0
	db ($5D & 3)+1, 0
	db ($5C & 3)+1, 0
	db ($5B & 3)+1, 0
	db ($59 & 3)+1, 0
	db ($58 & 3)+1, 0
	db ($56 & 3)+1, 0
	db ($54 & 3)+1, 0
	db ($53 & 3)+1, 0
	db ($51 & 3)+1, 0
	db ($4F & 3)+1, 0
	db ($4E & 3)+1, 0
	db ($4C & 3)+1, 0
	db ($4A & 3)+1, 0
	db ($49 & 3)+1, 0
	db ($47 & 3)+1, 0
	db ($46 & 3)+1, 0
	db ($45 & 3)+1, 0
	db ($44 & 3)+1, 0
	db ($43 & 3)+1, 0
	db ($42 & 3)+1, 0
	db ($41 & 3)+1, 0
	
	db 4, ($41 & 3)+1
	db 4, ($41 & 3)+1
	db 4, ($41 & 3)+1
	db 4, ($41 & 3)+1
	db 4, ($41 & 3)+1
	db 4, ($42 & 3)+1
	db 4, ($43 & 3)+1
	db 4, ($44 & 3)+1
	db 4, ($45 & 3)+1
	db 4, ($47 & 3)+1
	db 4, ($48 & 3)+1
	db 4, ($4A & 3)+1
	db 4, ($4D & 3)+1
	db 4, ($4F & 3)+1
	db 4, ($52 & 3)+1
	db 4, ($55 & 3)+1
	db 4, ($58 & 3)+1
	db 4, ($5C & 3)+1
	db 4, ($5F & 3)+1
	db 4, ($63 & 3)+1
	db 4, ($67 & 3)+1
	db 4, ($6B & 3)+1
	db 4, ($70 & 3)+1
	db 4, ($74 & 3)+1
	db 4, ($79 & 3)+1
	db 4, ($7E & 3)+1
	db 4, ($83 & 3)+1
	db 4, ($88 & 3)+1
	db 4, ($8D & 3)+1
	db 4, ($92 & 3)+1
	db 4, ($97 & 3)+1
	db 4, ($9D & 3)+1
	db 4, ($9F & 3)+1
	
reveal_data_start_addr
	dw 0
	dw 0
	dw 0
	
	dw 0
	dw 0
	dw 0
	
	dw 0
	dw 0
	dw 0
	
	dw 0
	dw 0
	dw 0
	
	dw ($05 & $FC)*2-8,($0B & $FC)*2-8,($10 & $FC)*2-8,($15 & $FC)*2-8,($1A & $FC)*2-8,($1F & $FC)*2-8,($24 & $FC)*2-8,($29 & $FC)*2-8
	dw ($2E & $FC)*2-8,($32 & $FC)*2-8,($37 & $FC)*2-8,($3B & $FC)*2-8,($3F & $FC)*2-8,($43 & $FC)*2-8,($46 & $FC)*2-8
	dw ($4A & $FC)*2-8,($4D & $FC)*2-8,($50 & $FC)*2-8,($53 & $FC)*2-8,($55 & $FC)*2-8,($58 & $FC)*2-8,($5A & $FC)*2-8,($5B & $FC)*2-8
	dw ($5D & $FC)*2-8,($5E & $FC)*2-8,($5F & $FC)*2-8,($60 & $FC)*2-8,($61 & $FC)*2-8,($61 & $FC)*2-8,($61 & $FC)*2-8,($61 & $FC)*2-8
	dw ($61 & $FC)*2-8
	
	dw ($61 & $FC)*2,($60 & $FC)*2,($5F & $FC)*2,($5E & $FC)*2,($5D & $FC)*2,($5C & $FC)*2,($5B & $FC)*2
	dw ($59 & $FC)*2,($58 & $FC)*2,($56 & $FC)*2,($54 & $FC)*2,($53 & $FC)*2,($51 & $FC)*2,($4F & $FC)*2,($4E & $FC)*2
	dw ($4C & $FC)*2,($4A & $FC)*2,($49 & $FC)*2,($47 & $FC)*2,($46 & $FC)*2,($45 & $FC)*2,($44 & $FC)*2,($43 & $FC)*2
	dw ($42 & $FC)*2,($41 & $FC)*2
	
	dw ($41 & $FC)*2-8,($41 & $FC)*2-8,($41 & $FC)*2-8,($41 & $FC)*2-8,($41 & $FC)*2-8,($42 & $FC)*2-8
	dw ($43 & $FC)*2-8,($44 & $FC)*2-8,($45 & $FC)*2-8,($47 & $FC)*2-8,($48 & $FC)*2-8,($4A & $FC)*2-8,($4D & $FC)*2-8,($4F & $FC)*2-8
	dw ($52 & $FC)*2-8,($55 & $FC)*2-8,($58 & $FC)*2-8,($5C & $FC)*2-8,($5F & $FC)*2-8,($63 & $FC)*2-8,($67 & $FC)*2-8,($6B & $FC)*2-8
	dw ($70 & $FC)*2-8,($74 & $FC)*2-8,($79 & $FC)*2-8,($7E & $FC)*2-8,($83 & $FC)*2-8
	dw ($88 & $FC)*2-8
	dw ($8D & $FC)*2-8,($92 & $FC)*2-8
	dw ($97 & $FC)*2-8,($9D & $FC)*2-8
	dw ($9F & $FC)*2-8 
	;
	dw $8080	; stop flag
	
	align 256
lum1	
	db $00,$20,$40,$60,$70,$70,$60,$40,$20,$00,$30,$40,$70,$70,$40,$30
	db $00,$10,$30,$60,$70,$70,$60,$30,$00,$10,$30,$40,$70,$70,$60,$30
	db $10,$20,$30,$60,$70,$70,$70,$60,$30,$20,$10,$00,$20,$30,$70,$70
	db $70,$70,$70,$30,$20,$00,$10,$30,$30,$60,$70,$70,$60,$60,$30,$30
	db $00,$10,$30,$30,$60,$70,$70,$70,$60,$60,$30,$30,$20,$00,$10,$30
	db $30,$30,$50,$60,$60,$70,$70,$70,$70,$60,$60,$50,$30,$30,$30,$10
	db $10,$30,$30,$30,$50,$60,$60,$70,$70,$70,$60,$60,$50,$30,$30,$30
	db $10,$30,$40,$60,$70,$70,$70,$70,$60,$40,$30,$10,$00,$20,$30,$30
	db $40,$60,$70,$70,$70,$70,$70,$70,$60,$40,$30,$30,$20,$00,$00,$20
	db $40,$40,$00,$00,$10,$30,$40,$60,$70,$70,$70,$70,$70,$70,$60,$40
	db $30,$10,$10,$00,$20,$10,$30,$30,$60,$70,$70,$60,$60,$30,$30,$00
	db $10,$30,$30,$30,$50,$60,$60,$70,$70,$70,$60,$60,$50,$30,$30,$30
	db $10,$30,$30,$30,$50,$60,$60,$70,$70,$70,$60,$60,$50,$30,$30,$30
	db $10,$20,$30,$60,$70,$70,$70,$60,$30,$20,$10,$00,$20,$30,$70,$70
	db $70,$70,$70,$30,$20,$00,$10,$30,$30,$60,$70,$70,$60,$60,$30,$30
	db $00,$10,$30,$30,$60,$70,$70,$70,$60,$60,$30,$30,$20,$00,$60,$00
lum2
	db $02,$03,$04,$06,$07,$06,$04,$03,$02,$02,$03,$06,$07,$06,$03,$02
	db $00,$03,$04,$06,$07,$06,$04,$02,$01,$02,$03,$06,$07,$07,$03,$02
	db $01,$03,$03,$06,$07,$07,$06,$03,$03,$01,$02,$01,$03,$04,$07,$07
	db $07,$07,$04,$03,$01,$02,$03,$03,$06,$06,$07,$07,$06,$03,$03,$01
	db $02,$03,$03,$06,$06,$07,$07,$07,$06,$03,$03,$01,$00,$01,$03,$03
	db $03,$05,$06,$06,$07,$07,$07,$07,$06,$06,$05,$03,$03,$03,$01,$00
	db $01,$03,$03,$03,$05,$06,$06,$07,$07,$06,$06,$05,$03,$03,$03,$01
	db $02,$03,$06,$06,$07,$07,$07,$06,$06,$03,$02,$00,$00,$02,$03,$03
	db $04,$06,$06,$07,$07,$07,$06,$06,$04,$03,$03,$02,$00,$00,$00,$04
	db $04,$02,$00,$00,$02,$03,$06,$06,$07,$07,$07,$07,$07,$06,$06,$03
	db $02,$00,$00,$00,$02,$03,$03,$06,$06,$07,$07,$06,$03,$03,$01,$00
	db $01,$03,$03,$03,$05,$06,$06,$07,$07,$06,$06,$05,$03,$03,$03,$01
	db $01,$03,$03,$03,$05,$06,$06,$07,$07,$06,$06,$05,$03,$03,$03,$01
	db $01,$03,$03,$06,$07,$07,$06,$03,$03,$01,$02,$01,$03,$04,$07,$07
	db $07,$07,$04,$03,$01,$02,$03,$03,$06,$06,$07,$07,$06,$03,$03,$01
	db $02,$03,$03,$06,$06,$07,$07,$07,$06,$03,$03,$01,$00,$02,$00,$02
col1 
	db $00,$01,$09,$01,$01,$01,$01,$09,$01,$0B,$06,$03,$03,$03,$03,$06
	db $0B,$05,$07,$05,$0C,$03,$0C,$03,$03,$09,$02,$0B,$0B,$01,$02,$02
	db $0E,$0E,$06,$06,$01,$01,$01,$06,$06,$0E,$0E,$01,$0B,$0B,$0B,$01
	db $01,$01,$0B,$0B,$0B,$01,$0C,$05,$0F,$07,$07,$01,$0A,$0F,$07,$0C
	db $01,$0C,$05,$0F,$07,$07,$01,$01,$0A,$0F,$07,$0C,$01,$00,$02,$02
	db $02,$0B,$02,$02,$0B,$0B,$01,$01,$0B,$0B,$02,$02,$0B,$02,$02,$02
	db $02,$02,$02,$0B,$02,$02,$0B,$0B,$01,$0B,$0B,$02,$02,$0B,$02,$02
	db $08,$09,$09,$08,$08,$01,$01,$08,$08,$09,$09,$08,$01,$03,$01,$01
	db $01,$01,$03,$0D,$01,$01,$0D,$03,$01,$01,$01,$01,$03,$01,$00,$01
	db $01,$01,$01,$01,$08,$09,$09,$08,$01,$01,$01,$01,$01,$01,$08,$09
	db $09,$08,$08,$01,$01,$0C,$05,$0F,$07,$07,$01,$0A,$0F,$07,$0C,$00
	db $02,$02,$02,$0B,$02,$02,$0B,$0B,$01,$0B,$0B,$02,$02,$0B,$02,$02
	db $02,$02,$02,$0B,$02,$02,$0B,$0B,$01,$0B,$0B,$02,$02,$0B,$02,$02
	db $0E,$0E,$06,$06,$01,$01,$01,$06,$06,$0E,$0E,$01,$0B,$0B,$0B,$01
	db $01,$01,$0B,$0B,$0B,$01,$0C,$05,$0F,$07,$07,$01,$0A,$0F,$07,$0C
	db $01,$0C,$05,$0F,$07,$07,$01,$01,$0A,$0F,$07,$0C,$01,$00,$01,$00
col2
	db $90,$10,$10,$10,$10,$10,$10,$10,$90,$40,$D0,$30,$10,$30,$D0,$40
	db $70,$A0,$70,$70,$10,$30,$30,$30,$70,$20,$20,$20,$10,$B0,$20,$20
	db $60,$60,$D0,$D0,$10,$10,$D0,$D0,$60,$60,$10,$B0,$E0,$D0,$40,$10
	db $10,$40,$D0,$E0,$B0,$10,$C0,$70,$F0,$A0,$10,$70,$70,$F0,$50,$C0
	db $10,$C0,$70,$F0,$A0,$10,$10,$70,$70,$F0,$50,$C0,$10,$20,$20,$20
	db $B0,$20,$20,$B0,$B0,$10,$10,$B0,$B0,$20,$20,$B0,$20,$20,$20,$00
	db $20,$20,$20,$B0,$20,$20,$B0,$B0,$B0,$B0,$20,$20,$B0,$20,$20,$20
	db $90,$90,$80,$80,$80,$10,$80,$80,$80,$90,$90,$00,$10,$10,$10,$10
	db $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$00,$10,$10
	db $10,$10,$00,$00,$90,$90,$80,$80,$80,$80,$10,$80,$80,$80,$80,$90
	db $90,$00,$10,$10,$10,$C0,$70,$F0,$A0,$10,$70,$70,$F0,$50,$C0,$00
	db $20,$20,$20,$B0,$20,$20,$B0,$B0,$B0,$B0,$20,$20,$B0,$20,$20,$20
	db $20,$20,$20,$B0,$20,$20,$B0,$B0,$B0,$B0,$20,$20,$B0,$20,$20,$20
	db $60,$60,$D0,$D0,$10,$10,$D0,$D0,$60,$60,$10,$B0,$E0,$D0,$40,$10
	db $10,$40,$D0,$E0,$B0,$10,$C0,$70,$F0,$A0,$10,$70,$70,$F0,$50,$C0
	db $10,$C0,$70,$F0,$A0,$10,$10,$70,$70,$F0,$50,$C0,$10,$10,$10,$10
	;
	align 256
	;	   
	; 93
sine
;93,22,0,0,3
	db $16,$17,$19,$1A,$1C,$1D,$1F,$20,$21,$23,$24,$25,$26,$27,$28,$29
	db $29,$2A,$2B,$2B,$2B,$2C,$2C,$2C,$2C,$2C,$2C,$2B,$2B,$2A,$2A,$29
	db $28,$27,$26,$25,$24,$23,$22,$21,$1F,$1E,$1D,$1B,$1A,$18,$17,$15
	db $14,$12,$11,$0F,$0E,$0D,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02
	db $02,$01,$01,$00,$00,$00,$00,$00,$00,$01,$01,$01,$02,$03,$03,$04
	db $05,$06,$07,$08,$09,$0B,$0C,$0D,$0F,$10,$12,$13,$15
	db $16,$17,$19,$1A,$1C,$1D,$1F,$20,$21,$23,$24,$25,$26,$27,$28,$29
	db $29,$2A,$2B,$2B,$2B,$2C,$2C,$2C,$2C,$2C,$2C,$2B,$2B,$2A,$2A,$29
	db $28,$27,$26,$25,$24,$23,$22,$21,$1F,$1E,$1D,$1B,$1A,$18,$17,$15
	db $14,$12,$11,$0F,$0E,$0D,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02
	db $02,$01,$01,$00,$00,$00,$00,$00,$00,$01,$01,$01,$02,$03,$03,$04
	db $05,$06,$07,$08,$09,$0B,$0C,$0D,$0F,$10,$12,$13,$15
	db $16,$17,$19,$1A,$1C,$1D,$1F,$20,$21,$23,$24,$25,$26,$27,$28,$29
	db $29,$2A,$2B,$2B,$2B,$2C,$2C,$2C,$2C,$2C,$2C,$2B,$2B,$2A,$2A,$29
	db $28,$27,$26,$25,$24,$23,$22,$21,$1F,$1E,$1D,$1B,$1A,$18,$17,$15
	db $14,$12,$11,$0F,$0E,$0D,$0B,$0A,$09,$08,$07,$06,$05,$04,$03,$02
	db $02,$01,$01,$00,$00,$00,$00,$00,$00,$01,$01,$01,$02,$03,$03,$04
	db $05,$06,$07,$08,$09,$0B,$0C,$0D,$0F,$10,$12,$13,$15
 
	align 256
	;
	; 79
sine2
;79,50,0,0,3
	db $32,$36,$3A,$3E,$42,$45,$49,$4C,$50,$53,$56,$58,$5B,$5D,$5F,$60
	db $62,$63,$64,$64,$64,$64,$63,$62,$61,$60,$5E,$5C,$5A,$57,$54,$51
	db $4E,$4B,$47,$44,$40,$3C,$38,$34,$30,$2C,$28,$24,$20,$1D,$19,$16
	db $13,$10,$0D,$0A,$08,$06,$04,$03,$02,$01,$00,$00,$00,$00,$01,$02
	db $04,$05,$07,$09,$0C,$0E,$11,$14,$18,$1B,$1F,$22,$26,$2A,$2E
	db $32,$36,$3A,$3E,$42,$45,$49,$4C,$50,$53,$56,$58,$5B,$5D,$5F,$60
	db $62,$63,$64,$64,$64,$64,$63,$62,$61,$60,$5E,$5C,$5A,$57,$54,$51
	db $4E,$4B,$47,$44,$40,$3C,$38,$34,$30,$2C,$28,$24,$20,$1D,$19,$16
	db $13,$10,$0D,$0A,$08,$06,$04,$03,$02,$01,$00,$00,$00,$00,$01,$02
	db $04,$05,$07,$09,$0C,$0E,$11,$14,$18,$1B,$1F,$22,$26,$2A,$2E
	db $32,$36,$3A,$3E,$42,$45,$49,$4C,$50,$53,$56,$58,$5B,$5D,$5F,$60
	db $62,$63,$64,$64,$64,$64,$63,$62,$61,$60,$5E,$5C,$5A,$57,$54,$51
	db $4E,$4B,$47,$44,$40,$3C,$38,$34,$30,$2C,$28,$24,$20,$1D,$19,$16
	db $13,$10,$0D,$0A,$08,$06,$04,$03,$02,$01,$00,$00,$00,$00,$01,$02
	db $04,$05,$07,$09,$0C,$0E,$11,$14,$18,$1B,$1F,$22,$26,$2A,$2E

	align 256
sine3
	db $04,$03,$04,$04,$03,$04,$03,$03,$03,$03,$02,$02,$02,$02,$02,$01
	db $01,$01,$00,$00,$00,$FF,$FF,$FF,$FF,$FE,$FE,$FE,$FE,$FD,$FD,$FD
	db $FD,$FD,$FC,$FD,$FC,$FD,$FC,$FC,$FC,$FD,$FC,$FD,$FC,$FD,$FD,$FD
	db $FD,$FD,$FE,$FE,$FE,$FE,$FF,$FF,$FF,$FF,$00,$00,$00,$01,$01,$01
	 
	db $02,$02,$02,$02,$02,$03,$03,$03,$03,$04,$03,$04,$04,$03,$04,$04
	db $03,$04,$04,$03,$04,$03,$03,$03,$03,$02,$02,$02,$02,$02,$01,$01
	db $01,$00,$00,$00,$FF,$FF,$FF,$FF,$FE,$FE,$FE,$FE,$FD,$FD,$FD,$FD
	db $FD,$FC,$FD,$FC,$FD,$FC,$FC,$FC,$FD,$FC,$FD,$FC,$FD,$FD,$FD,$FD
	 
	db $FD,$FE,$FE,$FE,$FE,$FF,$FF,$FF,$FF,$00,$00,$00,$01,$01,$01,$02
	db $02,$02,$02,$02,$03,$03,$03,$03,$04,$03,$04,$04,$03,$04,$04,$03
	db $04,$04,$03,$04,$03,$03,$03,$03,$02,$02,$02,$02,$02,$01,$01,$01
	db $00,$00,$00,$FF,$FF,$FF,$FF,$FE,$FE,$FE,$FE,$FD,$FD,$FD,$FD,$FD
	 
	db $FC,$FD,$FC,$FD,$FC,$FC,$FC,$FD,$FC,$FD,$FC,$FD,$FD,$FD,$FD,$FD
	db $FE,$FE,$FE,$FE,$FF,$FF,$FF,$FF,$00,$00,$00,$01,$01,$01,$02,$02
	db $02,$02,$02,$03,$03,$03,$03,$04,$03,$04,$04,$03,$D5,$00,$FF,$01
	db $00,$FF,$00,$01,$00,$FF,$00,$01,$00,$FF,$00,$01,$00,$FF,$00,$05

	;
	; ###############################################################
	;	

	org $2000
	include "pic1.asm"
	
	org $6000
	include "pic1_shifted.asm"
;eof
